<template>
  <div class="range-bar">
    <label class="range-info">
      <div class="skill-name">{{ skillName }}</div>
      <div class="range-box">
        <span
          class="range-box__current"
          :class="{ 'range-box__current-full': isFull }"
          >{{ rangeCurrent }}</span
        >
        &#47;
        <span
          class="range-box__max"
          :class="{ 'range-box__max-full': isFull }"
          >{{ rangeMax }}</span
        >
      </div>
      <input
        type="range"
        v-model="rangeCurrent"
        :min="rangeMin"
        :max="rangeMax"
        class="range-input"
      />
    </label>
  </div>
</template>

<script>
export default {
  name: 'RangeBar',

  props: {
    skillName: {
      type: String,
      default: '',
    },
    rangeMax: {
      type: Number,
      default: 10,
    },
    rangeCurrentDefault: {
      type: Number,
      default: 5,
    },
  },

  data() {
    return {
      rangeMin: 0,
      rangeCurrent: this.rangeCurrentDefault,
      isFull: false,
    }
  },

  methods: {
    setDefaultRanges() {
      this.$store.dispatch('SET_TOTAL_RANGE', this.rangeCurrentDefault)
      this.$store.dispatch('SET_MAX_RANGE', this.rangeMax)
    },
  },

  watch: {
    rangeCurrent(newValue, oldValue) {
      let payload = Number(newValue) - Number(oldValue)
      this.$store.dispatch('SET_TOTAL_RANGE', payload)
      this.isFull = Number(newValue) === this.rangeMax
    },
  },

  created() {
    this.setDefaultRanges()
  },
}
</script>
